#!/usr/bin/perl
# This file is part of the Savane project
# <http://gna.org/projects/savane/>
#
# $Id: Mail.pm,v 1.2 2004/09/22 08:11:52 yeupou Exp $
#
# Copyright 2004 (c) Mathieu Roy <yeupou--at--gnu.org>
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


##
## Desc: any subs related to mail sending.
## This module is not loaded by Savannah.pm
##

use strict "vars";
require Mail::Send;
require Exporter;

# Exports
our @ISA = qw(Exporter);
our @EXPORT = qw(MailSend);
our $version = 1;

# Fixme: for now, there's only very limited testing here, it should in the
# end looks like sendmail.php

# from, to, subject, message
# Note: don't forget to escape @, otherwise address will be treated as 
# list.
sub MailSend {
    
    my $msg = new Mail::Send;
        
    $msg->to($_[1]);
    $msg->subject($_[2]);
    if ($_[0] ne "") {
	$msg->add("From", $_[0]);
    } else {
	$msg->add("From", GetConf("sys_mail_replyto"));
    }
    $msg->add("X-Savane-Server", GetConf("sys_default_domain"));
    $msg->add("User-Agent", "Savannah::Mail.pm");

    my $fh = $msg->open;
    print $fh $_[3]."\n\n_______________________________________________
  Message sent via/by ".GetConf("sys_name")."
  http://".GetConf("sys_default_domain").GetConf("sys_url_topdir")."\n";
    $fh->close;
}

return true;
## EOF
